Index: branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsChangeLedgerData.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsChangeLedgerData.cs	(revision 50)
+++ branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsChangeLedgerData.cs	(revision 51)
@@ -67,6 +67,8 @@
             IOConstructionLedgerExcute LedgerExcuteDB = new IOConstructionLedgerExcute();
             try
             {
+                List<int> ConstrCodeList = new List<int>();
+
                 // 一括処理で登録を行う
                 CostDB.connect();
                 LedgerDB.connect();
@@ -79,8 +81,8 @@
                 // 対象をまず削除する(対象月で削除する)
                 string strDelSQL = "DELETE CONSTRUCTIONLEDGEREXCUTE";
                 strDelSQL += " WHERE CONSTRUCTIONCODE IN";
-                strDelSQL += " (SELECT CONSTRUCTIONCODE FROM CONSTRUCTIONBASEINFO";
-                strDelSQL += string.Format(" WHERE (SALESPERSONCODE = {0} OR CONSTRUCTIONPERSONCODE = {0} OR CONSTRSUBPERSONCODE = {0} OR CONSTRUCTIONINSTRUCTOR = {0}))", PersonCode);
+                strDelSQL += " (SELECT A1.CONSTRUCTIONCODE FROM CONSTRUCTIONBASEINFO A1";
+                strDelSQL += string.Format(" WHERE (A1.SALESPERSONCODE = {0} OR A1.CONSTRUCTIONPERSONCODE = {0} OR A1.CONSTRSUBPERSONCODE = {0} OR A1.CONSTRUCTIONINSTRUCTOR = {0}))", PersonCode);
                 strDelSQL += string.Format(" AND GROUPCOUNT IN ({0}, {1}, {2}, {3}, {4})"
                                                                 , GetConstructionLedgerGroupNo((int)CommonDefine.CostDataNo.Transport)
                                                                 , GetConstructionLedgerGroupNo((int)CommonDefine.CostDataNo.Purchase)
@@ -87,17 +89,17 @@
                                                                 , GetConstructionLedgerGroupNo((int)CommonDefine.CostDataNo.Lease)
                                                                 , GetConstructionLedgerGroupNo((int)CommonDefine.CostDataNo.StoragePlace)
                                                                 , GetConstructionLedgerGroupNo((int)CommonDefine.CostDataNo.Lodging));
-                strDelSQL += string.Format(" AND TARGETMONTH = DATE_FORMAT('{0}','%Y/%m/%d')", (TargetMonth + "/01"));
+                strDelSQL += string.Format(" AND TARGETMONTH = TO_DATE('{0}','YYYY/MM/DD')", (TargetMonth + "/01"));
                 LedgerExcuteDB.ExecuteNonQuery(strDelSQL, false);
 
                 for (int i = (int)CommonDefine.CostDataNo.Transport; i <= (int)CommonDefine.CostDataNo.Lodging; i++)
                 {
-                    string strSQL = "SELECT CONSTRUCTIONCODE, DATATYPE, DATE_FORMAT(ACTIONDATE,'%Y/%m'), SUM(ENTRYPRICE) FROM COSTDATAOFPERSON";
-                    strSQL += String.Format(" WHERE DATE_FORMAT(ACTIONDATE,'%Y/%m') = '{0}'", TargetMonth);
+                    string strSQL = "SELECT CONSTRUCTIONCODE, DATATYPE, TO_CHAR(ACTIONDATE,'YYYY/MM'), SUM(ENTRYPRICE) FROM COSTDATAOFPERSON";
+                    strSQL += String.Format(" WHERE TO_CHAR(ACTIONDATE,'YYYY/MM') = '{0}'", TargetMonth);
                     strSQL += String.Format(" AND DATATYPE = {0}", i);
-                    strSQL += " AND CONSTRUCTIONCODE IN (SELECT CONSTRUCTIONCODE FROM CONSTRUCTIONBASEINFO";
-                    strSQL += string.Format(" WHERE (SALESPERSONCODE = {0} OR CONSTRUCTIONPERSONCODE = {0} OR CONSTRSUBPERSONCODE = {0} OR CONSTRUCTIONINSTRUCTOR = {0}))", PersonCode);
-                    strSQL += " GROUP BY CONSTRUCTIONCODE, DATATYPE, DATE_FORMAT(ACTIONDATE,'%Y/%m')";
+                    strSQL += " AND CONSTRUCTIONCODE IN (SELECT A1.CONSTRUCTIONCODE FROM CONSTRUCTIONBASEINFO A1";
+                    strSQL += string.Format(" WHERE (A1.SALESPERSONCODE = {0} OR A1.CONSTRUCTIONPERSONCODE = {0} OR A1.CONSTRSUBPERSONCODE = {0} OR A1.CONSTRUCTIONINSTRUCTOR = {0}))", PersonCode);
+                    strSQL += " GROUP BY CONSTRUCTIONCODE, DATATYPE, TO_CHAR(ACTIONDATE,'YYYY/MM')";
                     strSQL += " ORDER BY CONSTRUCTIONCODE, DATATYPE";
                     ArrayList arList = new ArrayList();
                     if (!CostDB.ExecuteReader(strSQL, ref arList, false)) continue;
@@ -113,6 +115,8 @@
 
                         // 工事番号
                         int ConstructionCode = CommonMotions.cnvInt(wrkrec[0]);
+                        // 工事番号退避
+                        ConstrCodeList.Add(ConstructionCode);
 
                         // グループ番号
                         int DataType = i;
@@ -143,6 +147,12 @@
                 // DBコミット
                 LedgerExcuteDB.commit();
 
+                // 工事詳細台帳の更新
+                foreach (int ConstrCode in ConstrCodeList)
+                {
+                    LedgerRecalculate(ConstrCode);
+                }
+
                 return true;
             }
             catch (System.Exception ex)
@@ -161,6 +171,39 @@
         }
         #endregion
 
+        #region 工事詳細台帳再計算処理
+        /// <summary>
+        /// 工事詳細台帳再計算処理
+        /// </summary>
+        /// <param name="ConstrCode"></param>
+        private static void LedgerRecalculate(int ConstrCode)
+        {
+            FrmConstructionLedger frm = new FrmConstructionLedger();                    // 工事詳細台帳入力
+            try
+            {
+                // 工事コードのセット
+                frm.ConstructionCode = ConstrCode;
+
+                // 見えない画面を出す
+                frm.Hide();
+
+                // 再計算処理
+                bool bret = frm.RecalculateLedger;
+
+                // 画面を閉じる
+                frm.Close();
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
+
         #region 工事詳細台帳より対象データを探して実行データの行番号・列番号を返す（交通費・購入品等のみ）
         /// <summary>
         /// 工事詳細台帳より対象データを探して実行データの行番号・列番号を返す（交通費・購入品等のみ）
@@ -276,9 +319,9 @@
             FrmConstructionLedger frm = new FrmConstructionLedger();
             try
             {
-                string strSQL = "SELECT PERSONCODE, DATE_FORMAT(ACTIONDATE,'%Y/%m'), CONSTRUCTIONCODE FROM COSTDATAOFPERSON";
-                strSQL += String.Format(" WHERE PERSONCODE = {0} AND DATE_FORMAT(ACTIONDATE,'%Y/%m') = '{1}'", PersonCode, TargetMonth);
-                strSQL += " GROUP BY PERSONCODE, DATE_FORMAT(ACTIONDATE,'%Y/%m'), CONSTRUCTIONCODE";
+                string strSQL = "SELECT PERSONCODE, TO_CHAR(ACTIONDATE,'YYYY/MM'), CONSTRUCTIONCODE FROM COSTDATAOFPERSON";
+                strSQL += String.Format(" WHERE PERSONCODE = {0} AND TO_CHAR(ACTIONDATE,'YYYY/MM') = '{1}'", PersonCode, TargetMonth);
+                strSQL += " GROUP BY PERSONCODE, TO_CHAR(ACTIONDATE,'YYYY/MM'), CONSTRUCTIONCODE";
                 strSQL += " ORDER BY CONSTRUCTIONCODE";
 
                 ArrayList arList = new ArrayList();
@@ -452,9 +495,8 @@
         /// <param name="TargetDate">対象日</param>
         /// <param name="bSetFlag">月一括セットフラグ</param>
         /// <returns></returns>
-        public static bool CalculatePayment(int ConstrCode, DateTime TargetDate, bool bSetFlag = false)
+        public static bool CalculatePayment(ConstructionLedger LedgerRec, DateTime TargetDate, DateTime lastDate)
         {
-            IOConstructionLedger LedgerDB = new IOConstructionLedger();
             IOConstructionLedgerDetail LedgerDeDB = new IOConstructionLedgerDetail();
             IOConstructionLedgerExcute LedgerExDB = new IOConstructionLedgerExcute();
             IOMPersonInCharge PersonDB = new IOMPersonInCharge();
@@ -461,65 +503,50 @@
             FrmConstructionLedger frm = new FrmConstructionLedger();
             try
             {
-                // 工事詳細台帳データ取得
-                List<ConstructionLedger> LedgerList = new List<ConstructionLedger>();
-                string LedgerSQL = LedgerDB.CreatePrimarykeyString(ConstrCode);
-                if (!LedgerDB.SelectAction(LedgerSQL, ref LedgerList) || LedgerList.Count == 0) return false;
-
                 // 工事詳細台帳明細データ取得
                 List<ConstructionLedgerDetail> DetailList = new List<ConstructionLedgerDetail>();
-                string DetailSQL = LedgerDeDB.CreatePrimarykeyString(ConstrCode);
+                string DetailSQL = LedgerDeDB.CreatePrimarykeyString(LedgerRec.ConstructionCode);
                 DetailSQL += string.Format(" AND OperatingFlg = {0}", (int)CommonDefine.SalaryOperateKind.Oparateing);  // 対応中フラグ
+                DetailSQL += string.Format(" AND SALARYFLG != {0}", (int)CommonDefine.SalaryDevision.Noting);           // 給与振分区分
                 DetailSQL += string.Format(" AND GROUPCOUNT IN ({0},{1},{2})",
-                                                                (int)FrmConstructionLedger.DataGroup.Instructor,   // 指導員給料
-                                                                (int)FrmConstructionLedger.DataGroup.Assistant,    // 副担当者給料
-                                                                (int)FrmConstructionLedger.DataGroup.Payroll);     // 担当者給料行
+                                                                (int)FrmConstructionLedger.DataGroup.Instructor,        // 指導員給料
+                                                                (int)FrmConstructionLedger.DataGroup.Assistant,         // 副担当者給料
+                                                                (int)FrmConstructionLedger.DataGroup.Payroll);          // 担当者給料行
 
-                if (!LedgerDeDB.SelectAction(DetailSQL, ref DetailList) || DetailList.Count == 0) return false;
+                if (!LedgerDeDB.SelectAction(DetailSQL, ref DetailList) || DetailList.Count == 0) return true;
 
                 // 対象月より書込みカラム位置を取得する
-                int ColPoint = CalcTargetMonthToColumn(LedgerList[0].ConstructionStart, TargetDate);
-
-                // 対象月の開始日・終了日を取得する
-                DateTime dtStart = DateTimeUtil.BeginOfMonth(TargetDate);
-                DateTime dtLast = DateTimeUtil.EndOfMonth(TargetDate);
-                
-                // 開始月は開始月を入れる
-                if (LedgerList[0].ConstructionStart.Year == dtStart.Year
-                    && LedgerList[0].ConstructionStart.Month == dtStart.Month) dtStart = LedgerList[0].ConstructionStart;
-                
-                // 当月は今日より大きい場合は今日を入れる
-                if (DateTime.Now.Year == dtLast.Year
-                    && DateTime.Now.Month == dtLast.Month
-                    && DateTime.Now.Day < dtLast.Day) dtLast = DateTime.Now;
-                
-                // 終了月は終了日を入れる
-                if (LedgerList[0].ConstructionEnd.Year == dtLast.Year
-                    && LedgerList[0].ConstructionEnd.Month == dtLast.Month
-                    && LedgerList[0].ConstructionEnd.Day < dtLast.Day) dtLast = LedgerList[0].ConstructionEnd;
-
-                //// 稼働日数を取得する
-                //int WorkingDay = ClsCalendar.CalcOperatingDaysCount(dtStart, dtLast);
+                int ColPoint = CalcTargetMonthToColumn(LedgerRec.ConstructionStart, TargetDate);
                 // 経過日数を取得する
-                int WorkingDay = ClsCalendar.CalcPassedDaysCount(dtStart, dtLast);
+                TimeSpan ts = TargetDate - lastDate;
+                int WorkingDay = ts.Days;
 
                 LedgerExDB.connect(); LedgerExDB.beginTran();
                 PersonDB.connect(); PersonDB.beginTran();
 
-                bool LoopBreak = false;
                 foreach (ConstructionLedgerDetail CurRec in DetailList)
                 {
                     // コードが担当者ではない場合は処理しない
-                    if (CurRec.CompanyType != (int)CommonDefine.SearchLogDataType.Person) continue;
+                    if (CurRec.CompanyType != (int)CommonDefine.CodeDataType.Person) continue;
                     // コードがない場合は処理しない
                     if (CurRec.CompanyCode == 0) continue;
                     // 施工管理中担当者ではない場合は処理しない
                     if (CurRec.OperatingFlg == (int)CommonDefine.SalaryOperateKind.Complate) continue;
-                    // 実行金額が無い場合は処理しない
-                    if (CurRec.ExecutionAmount == 0) continue;
 
+                    // 現在の値を取得する
+                    int NowValue = 0;
+                    string strExecout = "SELECT PAYMENTAMOUNT FROM CONSTRUCTIONLEDGEREXCUTE";
+                    strExecout += LedgerExDB.CreatePrimarykeyString(CurRec.ConstructionCode, CurRec.GroupCount, CurRec.LineCount);
+                    strExecout += string.Format(" AND TargetMonth = TO_DATE('{0}')", DateTimeUtil.BeginOfMonth(TargetDate).ToShortDateString());
+                    ArrayList arExecList = new ArrayList();
+                    LedgerExDB.ExecuteReader(strExecout, ref arExecList, false);
+                    if (arExecList.Count != 0)
+                    {
+                       object[] objRec = (object[])arExecList[0];
+                       NowValue = CommonMotions.cnvInt(objRec[0]);
+                    }
+
                     // 1日分の給与を取得する
-                    //double dSaraly = Get1DaysSalaryForOperating(PersonDB, CurRec.CompanyCode);
                     double dSaraly = Get1DaysSalaryForFixed(PersonDB, CurRec.CompanyCode, CurRec.GroupCount);
 
                     switch (CurRec.SalaryFlg)
@@ -527,11 +554,12 @@
                         case (int)CommonDefine.SalaryDevision.All:          // 全日振分
                             // 指定日までの稼働日数を掛けた値をセットする
                             dSaraly *= WorkingDay;
+                            // 元の値を加算する
+                            dSaraly += NowValue;
                             break;
                         case (int)CommonDefine.SalaryDevision.Noting:       // 振分無
                             // 給与振分無
                             dSaraly = 0;
-                            LoopBreak = true;
                             break;
                         case (int)CommonDefine.SalaryDevision.DaysInput:    // 日数入力
                             // 日当加算判定を行う
@@ -544,20 +572,20 @@
                             {
                                 dSaraly = 0;
                             }
-                            LoopBreak = true;
                             break;
                         default:
                             break;
                     }
                     // 計算値が実行金額より大きい場合は処理しない
-                    if (CurRec.ExecutionAmount < dSaraly) continue;
+                    //if (CurRec.ExecutionAmount < dSaraly) continue;
 
                     DateTime ParaDate = new DateTime(TargetDate.Year, TargetDate.Month, 1);
                     // 支払いデータ書込み
                     if (!AddOrSetSalary(LedgerExDB
-                                    , ConstrCode, CurRec.GroupCount, CurRec.LineCount, ColPoint, (int)dSaraly, ParaDate))
+                                    , LedgerRec.ConstructionCode, CurRec.GroupCount, CurRec.LineCount, ColPoint, (int)dSaraly, ParaDate))
                     {
                         LedgerExDB.rollback();
+                        PersonDB.rollback();
                         return false;
                     }
                 }
@@ -567,7 +595,7 @@
                 bool bret = true;
 
                 // 工事コードのセット
-                frm.ConstructionCode = ConstrCode;
+                frm.ConstructionCode = LedgerRec.ConstructionCode;
 
                 // 見えない画面を出す
                 frm.Hide();
@@ -581,7 +609,7 @@
                 frm.Close();
 
                 // データ初期セット時に振分無・日数入力は次のループをしない
-                if (bSetFlag && LoopBreak) bret = false;
+                //if (bSetFlag && LoopBreak) bret = false;
 
                 return bret;
             }
@@ -592,7 +620,6 @@
             }
             finally
             {
-                LedgerDB.close(); LedgerDB = null;
                 LedgerDeDB.close(); LedgerDeDB = null;
                 LedgerExDB.close(); LedgerExDB = null;
                 PersonDB.close(); PersonDB = null;
@@ -637,51 +664,6 @@
         }
         #endregion
 
-        #region 平均稼働数より1日分の給与を取得する
-        /// <summary>
-        /// 平均稼働数より1日分の給与を取得する
-        /// </summary>
-        /// <param name="PersonCode"></param>
-        /// <returns></returns>
-        private static double Get1DaysSalaryForOperating(IOMPersonInCharge PersonDB, int PersonCode, int GroupCount)
-        {
-            try
-            {
-                int monthSalary = 0;
-                if (GroupCount == (int)FrmConstructionLedger.DataGroup.Payroll)
-                {   // 担当者給与の場合
-                    // 担当者マスタより給与月額を取得する
-                    string strPerson = PersonDB.CreatePrimarykeyString(PersonCode);
-                    PersonInChargeMaster personRec = new PersonInChargeMaster();
-                    PersonDB.SelectAction(strPerson, ref personRec, false);
-
-                    // 出勤補正値係数を掛ける
-                    monthSalary = CommonMotions.cnvRound(personRec.MonthlySalary * (double)CommonDefine.s_SalaryCorrection);
-                }
-                else if (GroupCount == (int)FrmConstructionLedger.DataGroup.Instructor)
-                {
-                    // 指導員月額を取得する
-                    monthSalary = CommonDefine.InstructorMonthryCost;
-                }
-                else if (GroupCount == (int)FrmConstructionLedger.DataGroup.Assistant)
-                {
-                    // 副担当者月額を取得する
-                    monthSalary = CommonDefine.AssistantMonthryCost;
-                }
-
-                // 計算値を月稼働日数で割る
-                double daylySalary = monthSalary / CommonDefine.s_WorkingDaysOfMonth;
-
-                return daylySalary;
-            }
-            catch (Exception ex)
-            {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
-                return 0;
-            }
-        }
-        #endregion
-
         #region 月工数より1日分の給与を取得する
         /// <summary>
         /// 月工数より1日分の給与を取得する
@@ -693,16 +675,16 @@
             try
             {
                 int monthSalary = 0;
-                
+
                 if (GroupCount == (int)FrmConstructionLedger.DataGroup.Payroll)
                 {   // 担当者給与の場合
-                    // 担当者マスタより給与月額を取得する
-                    string strPerson = PersonDB.CreatePrimarykeyString(PersonCode);
-                    PersonInChargeMaster personRec = new PersonInChargeMaster();
-                    PersonDB.SelectAction(strPerson, ref personRec, false);
+                    double MonthryCost = 0;
+                    double YearsCost = 0;
+                    // 担当者給与金額取得処理（セッションコネクト別）
+                    CommonMotions.GetSalaryValue(PersonDB, PersonCode, ref MonthryCost, ref YearsCost, DateTime.Today);
 
                     // 出勤補正値係数を掛ける
-                    monthSalary = CommonMotions.cnvRound(personRec.MonthlySalary * (double)CommonDefine.s_SalaryCorrection);
+                    monthSalary = CommonMotions.cnvRound(MonthryCost * (double)CommonDefine.s_SalaryCorrection);
 
                 }
                 else if (GroupCount == (int)FrmConstructionLedger.DataGroup.Instructor)
@@ -750,7 +732,7 @@
             {
                 // キー作成
                 string strSQL = LedgerExDB.CreatePrimarykeyString(ConstrCode, GroupCount, LineCount, ColumnCount);
-                strSQL += string.Format(" AND TargetMonth = DATE_FORMAT('{0}','%Y/%m/%d')", ColumnDate.ToShortDateString());
+                strSQL += string.Format(" AND DATE(TargetMonth) = STR_TO_DATE('{0}','%Y/%m/%d')", ColumnDate.ToShortDateString());
 
                 // データ読込み
                 List<ConstructionLedgerExcute> LedgerExDBList = new List<ConstructionLedgerExcute>();
@@ -766,10 +748,9 @@
                     LedgerExDBRec.TargetMonth = ColumnDate;         // 対象年月
                     
                     // データ作成
-                    bool bSaccess = LedgerExDB.InsertAction(LedgerExDBRec, false);
+                    if (!LedgerExDB.InsertAction(LedgerExDBRec, false)) return false;
                     
-                    if (bSaccess) return true;
-                    else return false;
+                    return true;
                 }
 
                 // データ更新
@@ -825,5 +806,111 @@
             }
         }
         #endregion
+
+        #region 結合工事作成処理
+        /// <summary>
+        /// 結合工事作成処理
+        /// </summary>
+        /// <returns></returns>
+        public static bool MakeJoinForBudgetData(int ConstructionCode, List<int> DateCodeList)
+        {
+            FrmConstructionLedger frm = new FrmConstructionLedger();
+            try
+            {
+                // 工事番号が存在しないデータは更新しない
+                if (ConstructionCode == 0) return false;
+
+                // 工事コードのセット
+                frm.ConstructionCode = ConstructionCode;
+
+                // 見えない画面を出す
+                frm.WindowState = FormWindowState.Minimized;
+                frm.Hide();
+                // フォーム非表示
+                frm.Visible = false;
+
+                bool bSuccess = true;
+
+                // データ追加処理
+                frm.JoiningCodeList = DateCodeList;
+                if (!frm.JoinDataLedger)
+                {
+                    bSuccess = false;
+                    return bSuccess;
+                }
+                
+                // データ保存処理
+                if (!frm.SaveLedgerData)
+                {
+                    bSuccess = false;
+                    return bSuccess;
+                }
+
+                // データ削除処理
+                if (!frm.RemoveJoinLedger)
+                {
+                    bSuccess = false;
+                    return bSuccess;
+                }
+
+                return bSuccess;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                // 画面を閉じる
+                frm.Close();
+
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
+
+        #region 結合工事疑似ロールバック処理
+        /// <summary>
+        /// 結合工事疑似ロールバック処理
+        /// </summary>
+        /// <returns></returns>
+        public static bool PseudoRollBackForBudgetData(int ConstructionCode, List<int> DateCodeList)
+        {
+            FrmConstructionLedger frm = new FrmConstructionLedger();
+            try
+            {
+                // 工事番号が存在しないデータは更新しない
+                if (ConstructionCode == 0) return false;
+
+                bool bSuccess = true;
+
+                // 工事コードのセット
+                frm.ConstructionCode = ConstructionCode;
+
+                // データ追加処理
+                frm.JoiningCodeList = DateCodeList;
+                frm.SetRollBackFlg = true;
+
+                // データ削除処理
+                if (!frm.RemoveJoinLedger)
+                {
+                    bSuccess = false;
+                    return bSuccess;
+                }
+
+                return bSuccess;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
     }
 }
